%DDEREQ	Request data from application.
%	DDEREQ requests data from a server application via an established DDE 
%	conversation.  DDEREQ returns a matrix containing the requested data 
%	or an empty matrix if the function is unsuccessful.
%
%	data = DDEREQ(channel,item,format,timeout)
%
%	data    Array containing requested data (may be empty if data contain
%		no numbers, no characters or was an empty FastDDE array)
%               Array is empty and logical if function fails.
%	channel Conversation channel from DDEINIT.
%	item    String specifying the server application's DDE item name 
%	        for the data requested.
%	format  (optional) If NUMERIC, a two-element array specifying the
%		format of the data requested. The first element indicates a
%		Windows clipboard format to use for the request. The value 1
%		corresponds to CF_Text, 13 for CF_UnicodeText;
%		other values can be obtained by	calling CLIPFORM.
%		The second element of the format array
%		specifies the type of the resultant matrix. The valid
%		types are NUMERIC (the default, corresponding to a value
%		of 0) and STRING (corresponding to a value of 1).
%		If no format given, the default format array is [1 0].
%		New: If STRING, this is the clipboard format name directly.
%		Supported formats are 'Text', 'UnicodeText',
%		'XlTable', and 'MatTable'.
%		The left-hand-side will be STRING if 'Text' and 'UnicodeText',
%		NUMERIC otherwise.
% 	timeout (optional) Scalar specifying the time-out limit for this
%	        operation.  Timeout is specified in milliseconds.
%	        (1000 milliseconds = 1 second). 
%	        The default timeout is three seconds.
%
%	For example,
%	Request a matrix of cells from Excel
%	mymtx = ddereq(channel, 'r1c1:r10c10');
%
%       See also DDEINIT, DDETERM, DDEEXEC, DDEPOKE, DDEADV, DDEUNADV, CLIPFORM.

%       Copyright (c) 2001 TU Chemnitz
